# --with reply_plugin
#        Default: --without
# Missing deps (perl(Reply::Plugin))
# Marked as unstable (cf. lib/Reply/Plugin/TypeTiny.pm)
%bcond_with reply_plugin

Name:           perl-Type-Tiny
Version:        1.012004
Release:        1%{?dist}
Summary:        Tiny, yet Moo(se)-compatible type constraint
License:        GPL+ or Artistic
URL:            http://typetiny.toby.ink/
Source0:        https://cpan.metacpan.org/modules/by-module/Test/Type-Tiny-%{version}.tar.gz
BuildArch:      noarch
# Module Build
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(CPAN::Meta::Requirements) >= 2.0
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  sed
# Module Runtime
BuildRequires:  perl(B)
BuildRequires:  perl(Exporter::Tiny) >= 1.000000
BuildRequires:  perl(overload)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(strict)
BuildRequires:  perl(Text::Balanced)
BuildRequires:  perl(utf8)
BuildRequires:  perl(warnings)
# Optional Module Runtime
BuildRequires:  perl(B::Deparse)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(Devel::LexAlias) >= 0.05
BuildRequires:  perl(Devel::StackTrace)
BuildRequires:  perl(mro)
BuildRequires:  perl(re)
BuildRequires:  perl(Ref::Util::XS) >= 0.100
%{?with_reply_plugin:
BuildRequires:  perl(Reply::Plugin)}
BuildRequires:  perl(Sub::Util)
%{?with_reply_plugin:
BuildRequires:  perl(Term::ANSIColor)}
BuildRequires:  perl(Type::Tie)
# Test Suite
BuildRequires:  perl(Config)
BuildRequires:  perl(constant)
BuildRequires:  perl(Encode)
BuildRequires:  perl(lib)
BuildRequires:  perl(Math::BigFloat)
BuildRequires:  perl(Test::Builder)
BuildRequires:  perl(Test::Fatal)
BuildRequires:  perl(Test::More) >= 0.96
BuildRequires:  perl(Test::Requires)
BuildRequires:  perl(threads)
# Optional Tests
BuildRequires:  perl(Benchmark)
BuildRequires:  perl(Devel::Cover)
BuildRequires:  perl(Devel::Hide)
BuildRequires:  perl(Devel::Refcount)
BuildRequires:  perl(Exporter) >= 5.59
BuildRequires:  perl(Function::Parameters) >= 1.0103
BuildRequires:  perl(IO::File)
BuildRequires:  perl(IO::String)
BuildRequires:  perl(JSON::PP) >= 2.27105
BuildRequires:  perl(match::simple)
BuildRequires:  perl(Method::Generate::Accessor)
BuildRequires:  perl(Moo) >= 1.006000
BuildRequires:  perl(Moo::Role)
BuildRequires:  perl(Moose) >= 2.1210
BuildRequires:  perl(Moose::Meta::TypeCoercion)
BuildRequires:  perl(Moose::Meta::TypeCoercion::Union)
BuildRequires:  perl(Moose::Meta::TypeConstraint)
BuildRequires:  perl(Moose::Meta::TypeConstraint::Class)
BuildRequires:  perl(Moose::Meta::TypeConstraint::DuckType)
BuildRequires:  perl(Moose::Meta::TypeConstraint::Enum)
BuildRequires:  perl(Moose::Meta::TypeConstraint::Union)
BuildRequires:  perl(Moose::Util::TypeConstraints)
BuildRequires:  perl(MooseX::Getopt) >= 0.63
BuildRequires:  perl(MooseX::Types)
BuildRequires:  perl(MooseX::Types::Common) >= 0.001004
BuildRequires:  perl(MooseX::Types::Moose)
BuildRequires:  perl(Mouse) >= 1.000
BuildRequires:  perl(Mouse::Meta::TypeConstraint)
BuildRequires:  perl(Mouse::Util)
BuildRequires:  perl(Mouse::Util::TypeConstraints)
BuildRequires:  perl(MouseX::Types) >= 0.06
BuildRequires:  perl(MouseX::Types::Moose)
BuildRequires:  perl(Object::Accessor) >= 0.30
BuildRequires:  perl(Role::Tiny)
BuildRequires:  perl(Role::Tiny::With)
BuildRequires:  perl(Specio)
BuildRequires:  perl(Sub::Exporter::Lexical) >= 0.092291
BuildRequires:  perl(Sub::Quote)
BuildRequires:  perl(Test::LeakTrace)
BuildRequires:  perl(Test::Memory::Cycle)
BuildRequires:  perl(Test::Moose)
BuildRequires:  perl(Test::Tester) >= 0.109
BuildRequires:  perl(Test::Warnings) >= 0.005
BuildRequires:  perl(Tie::Array)
BuildRequires:  perl(Tie::Hash)
BuildRequires:  perl(Tie::Scalar)
# Optional test requirements that depend on this package themselves
%if !0%{?perl_bootstrap:1}
BuildRequires:  perl(Return::Type) >= 0.007
BuildRequires:  perl(Types::Path::Tiny)
BuildRequires:  perl(Validation::Class) >= 7.900017
BuildRequires:  perl(Validation::Class::Simple)
%endif
# Dependencies
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:       perl(B::Deparse)
Requires:       perl(Carp)
Requires:       perl(Data::Dumper)
Requires:       perl(mro)
Requires:       perl(re)
Requires:       perl(Sub::Util)
Requires:       perl(Text::Balanced)
Recommends:     perl(Devel::LexAlias) >= 0.05
Recommends:     perl(Devel::StackTrace)
Recommends:     perl(Ref::Util::XS) >= 0.100
Recommends:     perl(Type::Tie)

# Optional Modules not yet available in EPEL-8
#TODO: BuildRequires:  perl(Class::InsideOut) >= 1.13
#TODO: BuildRequires:  perl(Data::Constraint)
#TODO: BuildRequires:  perl(Kavorka)
#TODO: BuildRequires:  perl(Moops)
#TODO: BuildRequires:  perl(MooX::TypeTiny)
#TODO: BuildRequires:  perl(MouseX::Types::Common) >= 0.001000
#TODO: BuildRequires:  perl(Regexp::Util) >= 0.003
#TODO: BuildRequires:  perl(Switcheroo)
#TODO: BuildRequires:  perl(Type::Tiny::XS)
#TODO: BuildRequires:  perl(Types::XSD::Lite)

%description
Type::Tiny is a tiny class for creating Moose-like type constraint objects
that are compatible with Moo, Moose and Mouse.

%package -n perl-Test-TypeTiny
Summary: Test::TypeTiny module

%description -n perl-Test-TypeTiny
Test::TypeTiny module.

%prep
%setup -q -n Type-Tiny-%{version}

# Remove bundled modules Test::Fatal, Test::Requires and Try::Tiny
rm -r ./inc/
sed -i -e '/^inc\//d' MANIFEST

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} -c %{buildroot}

%check
make test EXTENDED_TESTING=1

%files
%license COPYRIGHT LICENSE
%doc Changes CONTRIBUTING CREDITS NEWS README
%{perl_vendorlib}/Devel/
%{perl_vendorlib}/Error/
%{perl_vendorlib}/Eval/
%{!?with_reply_plugin:
%exclude }%{perl_vendorlib}/Reply/
%{perl_vendorlib}/Type/
%{perl_vendorlib}/Types/
%{_mandir}/man3/Devel::TypeTiny::Perl56Compat.3*
%{_mandir}/man3/Devel::TypeTiny::Perl58Compat.3*
%{_mandir}/man3/Error::TypeTiny.3*
%{_mandir}/man3/Error::TypeTiny::Assertion.3*
%{_mandir}/man3/Error::TypeTiny::Compilation.3*
%{_mandir}/man3/Error::TypeTiny::WrongNumberOfParameters.3*
%{_mandir}/man3/Eval::TypeTiny.3*
%{!?with_reply_plugin:
%exclude }%{_mandir}/man3/Reply::Plugin::TypeTiny.3*
%{_mandir}/man3/Type::Coercion.3*
%{_mandir}/man3/Type::Coercion::FromMoose.3*
%{_mandir}/man3/Type::Coercion::Union.3*
%{_mandir}/man3/Type::Library.3*
%{_mandir}/man3/Type::Params.3*
%{_mandir}/man3/Type::Parser.3*
%{_mandir}/man3/Type::Registry.3*
%{_mandir}/man3/Type::Tiny.3*
%{_mandir}/man3/Type::Tiny::Class.3*
%{_mandir}/man3/Type::Tiny::ConstrainedObject.3*
%{_mandir}/man3/Type::Tiny::Duck.3*
%{_mandir}/man3/Type::Tiny::Enum.3*
%{_mandir}/man3/Type::Tiny::Intersection.3*
%{_mandir}/man3/Type::Tiny::Manual.3*
%{_mandir}/man3/Type::Tiny::Manual::AllTypes.3*
%{_mandir}/man3/Type::Tiny::Manual::Coercions.3*
%{_mandir}/man3/Type::Tiny::Manual::Contributing.3*
%{_mandir}/man3/Type::Tiny::Manual::Installation.3*
%{_mandir}/man3/Type::Tiny::Manual::Libraries.3*
%{_mandir}/man3/Type::Tiny::Manual::NonOO.3*
%{_mandir}/man3/Type::Tiny::Manual::Optimization.3*
%{_mandir}/man3/Type::Tiny::Manual::Params.3*
%{_mandir}/man3/Type::Tiny::Manual::Policies.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithClassTiny.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo2.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo3.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoose.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMouse.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithOther.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithTestMore.3*
%{_mandir}/man3/Type::Tiny::Role.3*
%{_mandir}/man3/Type::Tiny::Union.3*
%{_mandir}/man3/Type::Tiny::_HalfOp.3*
%{_mandir}/man3/Type::Utils.3*
%{_mandir}/man3/Types::Common::Numeric.3*
%{_mandir}/man3/Types::Common::String.3*
%{_mandir}/man3/Types::Standard.3*
%{_mandir}/man3/Types::Standard::ArrayRef.3*
%{_mandir}/man3/Types::Standard::CycleTuple.3*
%{_mandir}/man3/Types::Standard::Dict.3*
%{_mandir}/man3/Types::Standard::HashRef.3*
%{_mandir}/man3/Types::Standard::Map.3*
%{_mandir}/man3/Types::Standard::ScalarRef.3*
%{_mandir}/man3/Types::Standard::StrMatch.3*
%{_mandir}/man3/Types::Standard::Tied.3*
%{_mandir}/man3/Types::Standard::Tuple.3*
%{_mandir}/man3/Types::TypeTiny.3*

%files -n perl-Test-TypeTiny
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::TypeTiny.3*

%changelog
* Mon Jan 10 2022 Paul Howarth <paul@city-fan.org> - 1.012004-1
- EPEL post-bootstrap rebuild

* Sat Jan  1 2022 Paul Howarth <paul@city-fan.org> - 1.012004-0
- Update to 1.012004 (see Changes file for details)
- Bootstrap for EPEL

* Fri Oct 25 2019 Paul Howarth <paul@city-fan.org> - 1.004004-2
- Prep for EPEL-8
  - Use author-independent source URL
  - Classify buildreqs by usage
  - Trim optional dependencies for EPEL-8
  - Use %%{make_build} and %%{make_install}
  - Fix permissions verbosely

* Fri Jan 11 2019 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.004004-1
- Update to 1.004004.

* Tue Aug 07 2018 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.004002-1
- Update to 1.004002.
- Add BR: perl(IO::String).
- Add and comment out BR: perl(MouseX::Types::Common).

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.002002-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Sat Jun 30 2018 Jitka Plesnikova <jplesnik@redhat.com> - 1.002002-3
- Perl 5.28 re-rebuild of bootstrapped packages

* Sat Jun 30 2018 Jitka Plesnikova <jplesnik@redhat.com> - 1.002002-2
- Perl 5.28 rebuild

* Mon May 21 2018 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.002002-1
- Update to 1.002002.
- Add BR: perl(Ref::Util::XS).

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.002001-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.002001-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Wed Jun 21 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.002001-1
- Update to 1.002001.

* Wed Jun 07 2017 Jitka Plesnikova <jplesnik@redhat.com> - 1.002000-2
- Perl 5.26 re-rebuild of bootstrapped packages

* Wed Jun 07 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.002000-1
- Update to 1.002000.

* Tue Jun 06 2017 Jitka Plesnikova <jplesnik@redhat.com> - 1.000006-7
- Perl 5.26 rebuild

* Mon Mar 20 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000006-6
- Don't BR: perl(Return::Type), perl(Types::Path::Tiny) if perl_bootstrapping
  (From ppisar@redhat.com, RHBZ#1433344)

* Mon Feb 13 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000006-5
- Add further optional part of testsuites: BR: perl(Validation::Class),
  perl(Validation::Class::Simple).

* Fri Feb 10 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000006-4
- Add further optional part of testsuite: BR: perl(Return::Type).

* Thu Feb 09 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000006-3
- Add further optional part of testsuite: BR: perl(Type::Tie).

* Thu Feb 09 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000006-2
- Add more optional parts of testsuite:
  - BR: perl(Sub::Exporter::Lexical).
  - BR: perl(Types::Path::Tiny).

* Thu Feb 02 2017 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000006-1
- Update to 1.000006.
- Add BuildRequires: perl(Function::Parameters)

* Mon May 16 2016 Jitka Plesnikova <jplesnik@redhat.com> - 1.000005-7
- Perl 5.24 rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.000005-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jan 29 2016 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000005-5
- Modernize spec.
- Add COPYRIGHT to %%license.

* Tue Jul 21 2015 Petr Pisar <ppisar@redhat.com> - 1.000005-4
- Specify all dependencies (bug #1245096)

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.000005-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Jun 08 2015 Jitka Plesnikova <jplesnik@redhat.com> - 1.000005-2
- Perl 5.22 rebuild

* Mon Oct 27 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000005-1
- Upstream update.

* Thu Sep 04 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000004-2
- Perl 5.20 rebuild

* Thu Sep 04 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000004-1
- Upstream update.

* Mon Sep 01 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000003-2
- Perl 5.20 rebuild

* Sun Aug 31 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000003-1
- Upstream update.

* Fri Aug 22 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000002-1
- Upstream update.
- Update deps.

* Mon Aug 18 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000000-1
- Upstream update.

* Thu Jul 24 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.046-1
- Upstream update.

* Mon Jun 23 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.044-1
- Upstream update.
- Spec file cosmetics.
- BR: perl(Test::Moose), perl(MooseX::Getopt).

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.042-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Apr 08 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.042-1
- Upstream update.
- Split out perl(Test::TypeTiny) to avoid deps on perl(Test::*).

* Fri Mar 21 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.040-1
- Initial Fedora package.
